"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * API for dimension's matches
 */
var express_1 = __importDefault(require("express"));
var auth_1 = require("../auth");
var router = express_1.default.Router();
/**
 * GET
 * Retrieves public user data for the user with the username userid or id userid
 */
router.get('/:userid', auth_1.storeAuth, function (req, res, next) {
    var dimension = req.data.dimension;
    var publicView = true;
    if (req.data.user) {
        if (req.data.user.username === req.params.userid ||
            req.data.user.playerID === req.params.userid) {
            publicView = false;
        }
        if (req.data.dimension.databasePlugin.isAdmin(req.data.user))
            publicView = false;
    }
    dimension.databasePlugin
        .getUser(req.params.userid, publicView)
        .then(function (user) {
        res.json({ error: null, user: user });
    })
        .catch(next);
});
router.get('/', auth_1.requireAuth, function (req, res, next) {
    var dimension = req.data.dimension;
    var publicView = false;
    dimension.databasePlugin
        .getUser(req.data.user.playerID, publicView)
        .then(function (user) {
        res.json({ error: null, user: user });
    })
        .catch(next);
});
exports.default = router;
//# sourceMappingURL=index.js.map