/// <reference types="node" />
import { ChildProcess } from 'child_process';
import { Agent } from '../Agent';
export declare const isChildProcess: (p: unknown) => p is ChildProcess;
export declare class AgentClassTypeGuards {
    /**
     * Type guard for checking if the agent meta data passed in are just file strings
     */
    static isGenerationMetaData_FilesOnly(p: unknown): p is Agent.GenerationMetaData_FilesOnly;
    /**
     * Type guard for checking if the agent meta data passed include names and files
     */
    static isGenerationMetaData_CreateMatch(p: unknown): p is Agent.GenerationMetaData_CreateMatch;
    /**
     * Type guard for checking if the agent meta data passed include names and files and tournament ids
     */
    static isGenerationMetaData_Tournament(p: unknown): p is Agent.GenerationMetaData_Tournament;
}
