"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var nanoid_1 = require("nanoid");
/**
 * Pick stuff
 * @param obj - object to pick out from
 * @param params - fields to pick out
 */
exports.pick = function (obj) {
    var params = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        params[_i - 1] = arguments[_i];
    }
    var picked = {};
    params.forEach(function (key) {
        picked[key] = obj[key];
    });
    return picked;
};
var ALPHA_NUM_STRING = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
// Map from length to id generator for that length
var idGenFunctionMap = new Map();
for (var i = 4; i <= 22; i++) {
    idGenFunctionMap.set(i, nanoid_1.customAlphabet(ALPHA_NUM_STRING, i));
}
/**
 * Generate unique IDs using nanoid
 * @param n - length of id
 */
exports.genID = function (n) {
    return idGenFunctionMap.get(n)();
};
exports.stripFunctions = function (object) {
    var seen = new Set();
    var helper = function (object) {
        for (var key in object) {
            if (!seen.has(key)) {
                seen.add(key);
                if (typeof object[key] === 'function') {
                    delete object[key];
                    continue;
                }
                else if (object[key] !== null &&
                    object[key] !== undefined &&
                    object[key].constructor.name === 'Array') {
                    continue;
                }
                helper(object[key]);
            }
        }
        // eslint-disable-next-line @typescript-eslint/ban-ts-comment
        // @ts-ignore
        return object;
    };
    return helper(object);
};
exports.stripNull = function (object) {
    var seen = new Set();
    var helper = function (object) {
        for (var key in object) {
            if (!seen.has(key)) {
                seen.add(key);
                if (object[key] === null) {
                    delete object[key];
                }
                else {
                    helper(object[key]);
                }
            }
        }
        return object;
    };
    return helper(object);
};
/**
 * Async function that resolves after `ms` milliseconds
 * @param ms - number of milliseconds to sleep for
 */
exports.sleep = function (ms) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        return [2 /*return*/, new Promise(function (resolve) {
                setTimeout(function () {
                    resolve();
                }, ms);
            })];
    });
}); };
// eslint-disable-next-line @typescript-eslint/no-empty-function
exports.noop = function () { };
//# sourceMappingURL=index.js.map